## ClickHouse-Extras-libcpuid-8db3b8d_GH0.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

set(VERSION "0.4.1")
project(cpuid LANGUAGES C CXX ASM_MASM VERSION ${VERSION})

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_C_STANDARD 99)

add_subdirectory(libcpuid)
add_subdirectory(cpuid_tool)

=== cpuid_tool/CMakeLists.txt ===
add_executable(cpuid_tool cpuid_tool.c)
target_link_libraries(cpuid_tool PRIVATE cpuid)

install(TARGETS cpuid_tool
        CONFIGURATIONS Debug
        RUNTIME DESTINATION bin/Debug)
install(TARGETS cpuid_tool
        CONFIGURATIONS Release
        RUNTIME DESTINATION bin/Release)

=== libcpuid/CMakeLists.txt ===
set(cpuid_sources cpuid_main.c
    recog_intel.c
    recog_amd.c
    rdtsc.c
    libcpuid_util.c
    rdmsr.c
    msrdriver.c
    asm-bits.c)

if ("${MSVC_CXX_ARCHITECTURE_ID}" MATCHES "x64")
    list(APPEND cpuid_sources masm-x64.asm)
endif ()

add_library(cpuid
            ${cpuid_sources}
            )
target_include_directories(cpuid SYSTEM PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

target_compile_definitions(cpuid PRIVATE VERSION="${PROJECT_VERSION}")
set(CPUID_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/libcpuid.h ${CMAKE_CURRENT_SOURCE_DIR}/libcpuid_constants.h ${CMAKE_CURRENT_SOURCE_DIR}/libcpuid_types.h)
set_target_properties(cpuid PROPERTIES
                      PUBLIC_HEADER "${CPUID_HEADERS}"
                      )

#Documentation
find_package(Doxygen)
option(ENABLE_DOCS "Enable building documentation." ON)
if (DOXYGEN_FOUND AND ENABLE_DOCS)
    set(top_srcdir ${PROJECT_SOURCE_DIR})
    configure_file(Doxyfile.in
                   Doxyfile
                   ESCAPE_QUOTES
                   )
    add_custom_target(docs
                      ALL
                      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/
                      COMMENT "Generating API documentation with Doxygen" VERBATIM
                      )
else ()
    add_custom_target(docs
                      echo "Doxygen was not installed when CMake was run or ENABLE_DOCS was OFF. Check that Doxygen is installed and rerun `cmake .`" VERBATIM
                      )
endif ()

#Configuration
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(config_install_dir "lib/cmake/${PROJECT_NAME}")
set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(TARGETS_EXPORT_NAME "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)

# Configure '<PROJECT-NAME>ConfigVersion.cmake'
# Use:
#   * PROJECT_VERSION
write_basic_package_version_file(
        "${version_config}" COMPATIBILITY SameMajorVersion
)

# Configure '<PROJECT-NAME>Config.cmake'
# Use variables:
#   * TARGETS_EXPORT_NAME
#   * PROJECT_NAME
configure_package_config_file(
        "${CMAKE_SOURCE_DIR}/cmake/Config.cmake.in"
        "${project_config}"
        INSTALL_DESTINATION "${config_install_dir}"
)
#Installation
install(TARGETS cpuid
        EXPORT "${TARGETS_EXPORT_NAME}"
        LIBRARY DESTINATION "lib"
        ARCHIVE DESTINATION "lib"
        RUNTIME DESTINATION "bin"
        INCLUDES DESTINATION "include")

install(FILES "${project_config}" "${version_config}"
        DESTINATION "${config_install_dir}"
        )
install(EXPORT "${TARGETS_EXPORT_NAME}"
        NAMESPACE "${namespace}"
        DESTINATION "${config_install_dir}"
        )

=== debian/changelog ===
libcpuid (0.4.1) unstable; urgency=low

  * Better support for Skylake Core i5 (#76)
  * Misdiagnosis microarchitecture for i3-3220T (#81)
  * Ability to dump MSR values to a file (PR #82)
  * AMD Ryzen support (#86)
  * Support for Coffee and Kaby Lake (#104)
  * Support for Raven Ridge and Threadripper (#106)
  * Support for Pinnacle Ridge (#111)
  * Fix P-III Celeron misdetection
  * Support for Skylake-X (#116)
  * Support for Zen+ Threadripper

 -- Georgiev, Veselin <anrieff@gmail.com>  Tue, 05 Feb 2019 22:36:00 +0200

libcpuid (0.4.0+ubuntu1~1) artful; urgency=low

  * built for artful
  * got rid of lintian errors

 -- Jeffrey Cliff <jeffrey.cliff@gmail.com>  Fri, 20 Apr 2018 15:39:37 +0600

libcpuid (0.4.0) unstable; urgency=low

  * Better detection of AMD clock multiplier with msrinfo.
  * Support for Intel SGX detection
  (a backwards-incompatible change since the sizeof
   cpu_raw_data_t and cpu_id_t is now different).

 -- Georgiev, Veselin <anrieff@gmail.com>  Fri, 30 Sep 2016 22:39:37 +0300

libcpuid (0.3.0) unstable; urgency=low

  * A backwards-incompatible change, since the sizeof cpu_raw_data_t and
	  cpu_id_t are now different.
  * Support for processors up to Skylake.
  * Fix clock detection in cpu_clock_by_ic() for Skylake.
  * Support up to 8 subleaf entries for CPUID leaf 04 and detection
	  of L4 cache.
  * MSR functions supported on FreeBSD.
  * INFO_VOLTAGE request supported by cpu_msrinfo().

 -- eloaders <eloaders@linux.pl>  Mon, 22 Aug 2016 17:45:21 +0200

libcpuid (0.2.1) unstable; urgency=low

  * Initial release add debian directory for libcpuid.

 -- Zhang, Guodong <gdzhang@linx-info.com>  Fri, 10 Apr 2015 14:59:27 +0800

=== debian/control ===
Source: libcpuid
Section: libs
Priority: optional
Maintainer: Zhang, Guodong <gdzhang@linx-info.com>
Build-Depends: debhelper (>= 9), autotools-dev, libtool, automake, autoconf, python, doxygen
Standards-Version: 3.9.5
Homepage: https://github.com/anrieff/libcpuid

Package: libcpuid14
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, ${misc:Pre-Depends}
Replaces: libcpuid11, libcpuid13
Description: small C library for x86/x86_64 CPU detection and feature extraction
 For details about the programming API, please see the docs
 on the project's site (http://libcpuid.sourceforge.net/)

Package: libcpuid14-dev
Architecture: amd64 i386
Section: libdevel
Depends: ${misc:Depends}
Replaces: libcpuid11-dev, libcpuid13-dev
Description: Development files for libcpuid
 For details about the programming API, please see the docs
 on the project's site (http://libcpuid.sourceforge.net/)

Package: cpuidtool
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, ${misc:Pre-Depends}
Replaces: cpuidtool
Description: small C library for x86/x86_64 CPU detection and feature extraction
 For details about the programming API, please see the docs
 on the project's site (http://libcpuid.sourceforge.net/)
